# Robot::Simulator

A robot simulator that can receive commands and move around on a table surface. It will prevent falling from the table, and can report its position.


## Installation

Install it using gem:

    $ gem install robot-simulator

Or directly from git repository:

    $ git clone https://mingliangfeng@bitbucket.org/mingliangfeng/robot-simulator.git
    $ cd robot-simulator
    $ bundle install
    $ bundle exec rspec


## Environment

* Ruby version: `ruby 2.1.2p95`, best to use rbenv to set the ruby version.


## Dependencies

* [thor](https://github.com/erikhuda/thor)
* [RSpec](https://github.com/rspec/rspec) for testing
* [rbenv](https://github.com/sstephenson/rbenv) for seting the right ruby version


## Usage

#### Use installation
Once installed, try the following, you will be asked for commands to instruct the robot to move:

    $ robot-simulator

Or alternatively run robot simulator with commands from a text file:

    $ robot-simulator -f /path/to/commands/text/file

#### Use source code
Get the source code from bitbucket as instructed in Installation section, go to robot-simulator folder and play straightaway:

    $ bundle exec bin/robot-simulator
    $ bundle exec bin/robot-simulator -f /path/to/commands/text/file


## Design

Please see the class diagram [here](https://repository.genmymodel.com/mingliangfeng/robot-simulator).


## Contributing

1. Fork it
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create new Pull Request
