require 'spec_helper'

module Robot
  module Simulator
    describe Direction do

      context 'test left' do

        it 'expect ArgumentError if not called by passing Direction constants value' do
          expect { Direction.left(-1) }.to raise_error(ArgumentError)
          expect { Direction.left(5) }.to raise_error(ArgumentError)
        end

        it 'left should return correct value' do
          expect( Direction.left(Direction::EAST) ).to eq(Direction::NORTH)
          expect( Direction.left(Direction::NORTH) ).to eq(Direction::WEST)
          expect( Direction.left(Direction::WEST) ).to eq(Direction::SOUTH)
          expect( Direction.left(Direction::SOUTH) ).to eq(Direction::EAST)
        end

      end

      context 'test right' do

        it 'expect ArgumentError if not called by passing Direction constants value' do
          expect { Direction.right(-1) }.to raise_error(ArgumentError)
          expect { Direction.right(5) }.to raise_error(ArgumentError)
        end

        it 'right should return correct value' do
          expect( Direction.right(Direction::EAST) ).to eq(Direction::SOUTH)
          expect( Direction.right(Direction::SOUTH) ).to eq(Direction::WEST)
          expect( Direction.right(Direction::WEST) ).to eq(Direction::NORTH)
          expect( Direction.right(Direction::NORTH) ).to eq(Direction::EAST)
        end

      end

      context 'test to_str' do

        it 'expect ArgumentError if not called by passing Direction constants value' do
          expect { Direction.to_str(-1) }.to raise_error(ArgumentError)
          expect { Direction.to_str(5) }.to raise_error(ArgumentError)
        end

        it 'to_str should return correct string value' do
          expect( Direction.to_str(Direction::EAST) ).to eq('EAST')
          expect( Direction.to_str(Direction::SOUTH) ).to eq('SOUTH')
          expect( Direction.to_str(Direction::WEST) ).to eq('WEST')
          expect( Direction.to_str(Direction::NORTH) ).to eq('NORTH')
        end

      end

      context 'test from_str' do

        it 'expect ArgumentError if not called by passing right string' do
          expect { Direction.from_str('east-weast') }.to raise_error(ArgumentError)
        end

        it 'from_str should return correct Direction constant' do
          expect( Direction.from_str('EAST') ).to eq(Direction::EAST)
          expect( Direction.from_str('south') ).to eq(Direction::SOUTH)
          expect( Direction.from_str('West') ).to eq(Direction::WEST)
          expect( Direction.from_str('NorTH') ).to eq(Direction::NORTH)
        end
        
      end

    end
  end
end
