require 'spec_helper'

module Robot
  module Simulator
    describe Table do

      let(:table) { Table.new 5, 5 }

      it 'constructor and getters' do
        expect( table.dimensionX ).to eq(5)
        expect( table.dimensionY ).to eq(5)
      end

      it 'test is_valid_coordinate?' do
    		expect( table.is_valid_coordinate?(Coordinate.new(0, 0)) ).to be true
    		expect( table.is_valid_coordinate?(Coordinate.new(4, 0)) ).to be true
    		expect( table.is_valid_coordinate?(Coordinate.new(4, 4)) ).to be true
    		expect( table.is_valid_coordinate?(Coordinate.new(0, 4)) ).to be true

    		expect( table.is_valid_coordinate?(Coordinate.new(0, -1)) ).to be false
    		expect( table.is_valid_coordinate?(Coordinate.new(-1, 0)) ).to be false
    		expect( table.is_valid_coordinate?(Coordinate.new(4, -1)) ).to be false
    		expect( table.is_valid_coordinate?(Coordinate.new(5, 0)) ).to be false
    		expect( table.is_valid_coordinate?(Coordinate.new(4, 5)) ).to be false
    		expect( table.is_valid_coordinate?(Coordinate.new(5, 4)) ).to be false
    		expect( table.is_valid_coordinate?(Coordinate.new(0, 5)) ).to be false
    		expect( table.is_valid_coordinate?(Coordinate.new(-1, 4)) ).to be false
      end

    end
  end
end
